#include <ROL_UpdateType.hpp>
#include <iterator>
#include <memory>
#include <string>

#include <functional>
#include <pybind11/pybind11.h>
#include <string>
#include <Teuchos_RCP.hpp>


#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, Teuchos::RCP<T>)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*)
	PYBIND11_MAKE_OPAQUE(Teuchos::RCP<void>)
#endif

void bind_pyrol_13(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	// ROL::UpdateType file:ROL_UpdateType.hpp line:52
	pybind11::enum_<ROL::UpdateType>(M("ROL"), "UpdateType", "", pybind11::module_local())
		.value("Initial", ROL::UpdateType::Initial)
		.value("Accept", ROL::UpdateType::Accept)
		.value("Revert", ROL::UpdateType::Revert)
		.value("Trial", ROL::UpdateType::Trial)
		.value("Temp", ROL::UpdateType::Temp);

;

	// ROL::UpdateTypeToString(const enum ROL::UpdateType &) file:ROL_UpdateType.hpp line:61
	M("ROL").def("UpdateTypeToString", (std::string (*)(const enum ROL::UpdateType &)) &ROL::UpdateTypeToString, "C++: ROL::UpdateTypeToString(const enum ROL::UpdateType &) --> std::string", pybind11::arg("type"));

}
